SystemOrganization addCategory: #'Cormas-Model-Diffuse'!

CMAgentLocation subclass: #CMDiffuseAnt
	instanceVariableNames: ''
	classVariableNames: 'CurrentId'
	poolDictionaries: ''
	category: 'Cormas-Model-Diffuse'!

!CMDiffuseAnt commentStamp: 'NicolasBecu 4/30/2018 09:38' prior: 0!
I'm an Ant in Diffuse model.
I diffuse hormons!

!CMDiffuseAnt class methodsFor: 'id' stamp: 'SergeStinckwich 4/3/2016 16:19'!
CurrentId
	^ CurrentId isNil
		ifTrue: [ 0 ]
		ifFalse: [ CurrentId ]! !

!CMDiffuseAnt class methodsFor: 'id' stamp: 'SergeStinckwich 4/3/2016 16:19'!
CurrentId: x
	^ CurrentId := x! !

!CMDiffuseAnt class methodsFor: 'pov symbols' stamp: 'SergeStinckwich 4/3/2016 16:19'!
VectorialPOV_Ant
	"Returns an array containing the settings of a Situated entity vectorial pov symbol in the following order:
(color red) (color green) (color blue) (lineColor red) (lineColor green) (lineColor blue) lineWidth sizeratio position (array of outline vertices)"

	^ #(1.0 1.0 0.0 0.0 0.0 0.0 1 0.5 #center #(0 #@- 17 15 #@- 9 15 #@ 8 0 #@ 17 -15 #@ 9 -15 #@- 9 0 #@- 17))! !

!CMDiffuseAnt class methodsFor: 'pov symbols' stamp: 'SergeStinckwich 4/3/2016 16:19'!
VectorialPOV_ant
	"Returns an array containing the settings of a Situated entity vectorial pov symbol in the following order:
(color red) (color green) (color blue) (lineColor red) (lineColor green) (lineColor blue) lineWidth sizeratio position (array of outline vertices)"
	
	^#(1.0 0.0 0.0 0.0 0.0 0.0 1 1 #center #(-1.74658 #@- 26.5929 10.1301 #@- 26.7143 23.4041 #@- 14.9357 5.93836 #@- 10.9286 24.1027 #@- 6.07143 8.73288 #@- 1.21429 23.4041 #@ 9.83571 1.74658 #@ 13.3571 21.3082 #@ 24.2857 -1.74658 #@ 22.95 -23.4041 #@ 24.2857 -6.63699 #@ 14.5714 -23.4041 #@ 8.5 -6.63699 #@- 1.21429 -24.8014 #@- 4.85714 -3.84247 #@- 12.1429 -26.8973 #@- 14.9357 -13.6233 #@- 26.7143 -1.74658 #@- 26.5929))! !

!CMDiffuseAnt class methodsFor: 'testing' stamp: 'SergeStinckwich 4/3/2016 16:19'!
isAbstract
	^ false! !

!CMDiffuseAnt methodsFor: 'init' stamp: 'SergeStinckwich 4/3/2016 16:18'!
init
	"to be completed. The inherited attributes should have been already initialized"

	! !

!CMDiffuseAnt methodsFor: 'init' stamp: 'SergeStinckwich 4/3/2016 16:18'!
initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CMDiffuseAnt methodsFor: 'control' stamp: 'SergeStinckwich 4/3/2016 16:18'!
letHormon
	self patch qty: 150! !

!CMDiffuseAnt methodsFor: 'pov' stamp: 'SergeStinckwich 4/3/2016 16:18'!
pov
	"return a symbol or a ColorValue"

	^ #ant	"^ColorValue white"! !

!CMDiffuseAnt methodsFor: 'control' stamp: 'SergeStinckwich 4/3/2016 16:18'!
randomWalk
	(self patch neighbourhood anySatisfy: [ :c | c qty > 60 ])
		ifFalse: [ super randomWalk ]
		ifTrue: [ self
				moveTo: (Cormas selectRandomlyFrom: (self patch layerOfRadius: 5)) ]! !

!CMDiffuseAnt methodsFor: 'control' stamp: 'SergeStinckwich 4/3/2016 16:18'!
step
	self randomWalk.
	self letHormon! !

CormasModel subclass: #CMDiffuseModel
	instanceVariableNames: 'theCMDiffuseCells theCMDiffuseAnts activeCells newActiveCells noMoreActiveCells antNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cormas-Model-Diffuse'!

!CMDiffuseModel commentStamp: 'HernanMoralesDurand 1/1/2018 19:31' prior: 0!
The model is available online here: http://cormas.cirad.fr/en/applica/diffuse.htm!

!CMDiffuseModel class methodsFor: 'description' stamp: 'HernanMoralesDurand 1/3/2018 02:12'!
aboutIt
	
	| txt |
	txt := 'This model illustrates how the principles of cellular automata are 
implemented in Cormas. 

The spatial entity of the model (the cell), named Cell, 
can take four states: #fire (red); #tree (green); #ash (grey); #empty (white). 
The initial state of each cell of the spatial grid is either set to #tree with a 
probability p or to #empty with a probability 1-p. 

One cell is set on fire, and then the spreading of the fire, defined in the 
cell transition function, occurs. The transition function is the following: 
a cell being a tree at time t-1 will become on fire at time t if at least 
one of its 4 neighbours (North, East, South, West) is on fire at time t-1. 
The cells being on fire will become ash at the next timestep, the cells 
being ash will become empty at the next timestep. 

The probability to observe a resteint fire is high if p is lower than 0.55, 
whereas when p is greater than 0.55, a global fire is likely to occur. 
This percolation threshold characterizes cellular automata which are 
representing diffusion processes.' asText emphasizeAllWith: #(#bold).
"	ComposedTextView
		open: txt asValue
		label: 'About ' , self name
		icon: (Icon constantNamed: #workspace)
		extent: 500 @ 430"! !

!CMDiffuseModel class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:21'!
activeCells_default
	"Return the default value of activeCells attribute"

	^ nil! !

!CMDiffuseModel class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:21'!
antNumber_default
	"Return the default value of antNumber attribute"

	^ 1! !

!CMDiffuseModel class methodsFor: 'description' stamp: 'SergeStinckwich 4/3/2016 16:21'!
cormasCompatibleVersion
	^ #(2011 9 18 10 47 32)! !

!CMDiffuseModel class methodsFor: 'examples' stamp: 'NicolasBecu 5/13/2018 07:56'!
example1
	| aModel |
	aModel := self initialize new initSimulation.
	(CMSimulationGrid new
		on: aModel
		withCells: aModel theESE
		withSituatedEntities: aModel allTheSituatedEntities) runAndVisualize! !

!CMDiffuseModel class methodsFor: 'description' stamp: 'HernanMoralesDurand 1/1/2018 20:58'!
howToInstructions

	^ String streamContents: [ : stream |
		stream 
			nextPutAll: '1. Prepare the visualisation of the spatial grid\' withCRs asText;
			nextPutAll: '1.1 Click on the first icon of the ' asText;
			nextPutAll: ('Visualisation ' asText emphasized: TextEmphasis bold emphasisCode);
			nextPutAll: 'area to open the standard spatial grid.\' withCRs asText;
			nextPutAll: '1.2 In the ' asText;
			nextPutAll: ('Topology ' asText emphasizeAllWith: #italic);
			nextPutAll: 'menu, clicking on the ' asText;
			nextPutAll: ('Grid size ' asText emphasizeAllWith: #italic);
			nextPutAll: 'item opens a window allowing you to choose the number of lines and columns. For example, choose 30 * 30.\' withCRs asText;
			nextPutAll: '1.3 Check the border condition: ' asText;
			nextPutAll: ('Topology -> Grid boundaries -> closed' asText emphasizeAllWith: #italic);
			nextPutAll: '.\' withCRs asText;
			nextPutAll: '1.4 Right-click within the spatial grid window to select the ' asText;
			nextPutAll: ('pov ' asText emphasizeAllWith: #italic);
			nextPutAll: 'view for ' asText;
			nextPutAll: ('Cell ' asText emphasizeAllWith: #italic);
			nextPutAll: '.\' withCRs asText;
			nextPutAll: '1.5 To display the legend of this viewpoint: ' asText;
			nextPutAll: ('Tools -> Display legends.\\' withCRs asText emphasizeAllWith: #italic);
			nextPutAll:('2. Prepare the initial spatial grid\' withCRs asText emphasizeAllWith: #(#bold #large));
			nextPutAll: '2.1 Click on the ' asText , ('Initialize ' asText emphasizeAllWith: #italic);
			nextPutAll: 'button of the ' asText;
			nextPutAll: ('Simulation ' asText emphasizeAllWith: #color -> Color red);
			nextPutAll: 'area.\' withCRs asText;
			nextPutAll: '2.2 Select the ' asText;
			nextPutAll: ('init53 ' asText emphasizeAllWith: #italic);
			nextPutAll: 'and ' asText;
			nextPutAll: ('stepSynchronously: ' asText emphasizeAllWith: #italic);
			nextPutAll: 'methods, then validate by clicking on ' asText;
			nextPutAll: ('Apply and close.\' asText emphasizeAllWith: #italic) withCRs asText;
			nextPutAll: '2.3 From the spatial grid menu, use ' asText;
			nextPutAll: ('Tools -> Click to... -> Change attribute... -> state' asText emphasizeAllWith: #italic);
			nextPutAll: ', enter ' asText;
			nextPutAll: ('fire ' asText emphasizeAllWith: #italic);
			nextPutAll: 'and validate. The cursor takes a new shape. Click on a cell to change manually its state to fire, then switch back to the mouse select mode with '	asText;
			nextPutAll: ('Tools -> Click to... -> Select ' asText emphasizeAllWith: #italic);
			nextPutAll: '.\\' withCRs asText;
			nextPutAll: ('3. Run the model\' withCRs asText emphasizeAllWith: #(#bold #large));
			nextPutAll: '3.1 Enter 50 in the ' asText;
			nextPutAll: ('Final time ' asText emphasizeAllWith: #italic);
			nextPutAll: 'input field of the ' asText;
			nextPutAll: ('Simulation ' asText emphasizeAllWith: #color -> Color red);
			nextPutAll: 'area.\' withCRs asText;
			nextPutAll: '3.2 Click on the ' asText;
			nextPutAll: ('Run ' asText emphasizeAllWith: #italic);
			nextPutAll: 'button of the ' asText;
			nextPutAll: ('Simulation ' asText emphasizeAllWith: #color -> Color red) , 'area.\\' withCRs asText;
			nextPutAll: ('4. Have a look at the charts\' withCRs asText emphasizeAllWith: #(#bold #large));
			nextPutAll: '4.1 Click on the third icon of the ' asText;
			nextPutAll: ('Visualisation ' asText emphasizeAllWith: #color -> Color red);
			nextPutAll: 'area to open the charts window.\\' withCRs asText;
			nextPutAll: ('5. Run alternative versions of the model\' withCRs asText emphasizeAllWith: #(#bold #large));
			nextPutAll: '5.1 Select the ' asText;
			nextPutAll: ('init58 ' asText emphasizeAllWith: #italic);
			nextPutAll: 'and ' asText;
			nextPutAll: ('stepSynchronously: ' asText emphasizeAllWith: #italic);
			nextPutAll: 'methods, then run the model again.\' withCRs asText;
			nextPutAll: '5.2 Select the ' asText;
			nextPutAll: ('init53 ' asText emphasizeAllWith: #italic);
			nextPutAll: 'and ' asText;
			nextPutAll: ('stepAsynchronously: ' asText emphasizeAllWith: #italic);
			nextPutAll: 'methods, then run the model again.\' withCRs asText ]! !

!CMDiffuseModel class methodsFor: 'description' stamp: 'HernanMoralesDurand 1/1/2018 20:59'!
howToRunIt

	| dialog |
	
	dialog := LongMessageDialogWindow new
		entryText: self howToInstructions;
		title: 'How to run ' , self name , '     step-by-step instructions';
		yourself.
	dialog open.
	dialog textMorph
		minWidth: 60;
		minHeight: 90.! !

!CMDiffuseModel class methodsFor: 'testing' stamp: 'SergeStinckwich 4/3/2016 16:22'!
isAbstract
	^ false! !

!CMDiffuseModel class methodsFor: 'description' stamp: 'SergeStinckwich 4/3/2016 16:22'!
lastUpdate
	^ 'lundi 19 septembre 2011'! !

!CMDiffuseModel class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:22'!
newActiveCells_default
	"Return the default value of newActiveCells attribute"

	^ nil! !

!CMDiffuseModel class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:22'!
noMoreActiveCells_default
	"Return the default value of noMoreActiveCells attribute"

	^ nil! !

!CMDiffuseModel class methodsFor: 'description' stamp: 'SergeStinckwich 4/3/2016 16:22'!
version
	^ 'Diffuse.pcl'! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:11'!
activeCells
	^ activeCells! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:11'!
activeCells: anObject
	activeCells := anObject! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:11'!
antNumber
	"Getter accessor with default value = 1 "

	antNumber isNil
		ifTrue: [ antNumber := 1 ].
	^ antNumber! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:11'!
antNumber: aNumber
	antNumber := aNumber! !

!CMDiffuseModel methodsFor: 'init' stamp: 'NicolasBecu 4/29/2018 23:07'!
init
	self spaceModel loadEnvironmentFromFile: '40x40.env' withPov: #pov.
	self initOptimize.
	self initCells: #initEmpty.
	self setRandomlyLocatedAgents: CMDiffuseAnt n: self antNumber! !

!CMDiffuseModel methodsFor: 'optimize' stamp: 'SergeStinckwich 8/17/2017 15:11'!
initOptimize
	CMDiffuseCell scheduler: self.
	self activeCells: Set new.
	self newActiveCells: Bag new.
	self noMoreActiveCells: Bag new! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:12'!
newActiveCells
	^ newActiveCells! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:12'!
newActiveCells: anObject
	newActiveCells := anObject! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:12'!
noMoreActiveCells
	^ noMoreActiveCells! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:12'!
noMoreActiveCells: anObject
	noMoreActiveCells := anObject! !

!CMDiffuseModel methodsFor: 'control' stamp: 'NicolasBecu 4/29/2018 23:09'!
step: t
	self activeCells
		do: [ :a | 
			a evaporate.
			a diffuse ].
	self updateActiveCells.
	self activeCells do: [ :a | a updateState ].
	self theCMDiffuseAnts do: [ :a | a step ].
	self updateActiveCells! !

!CMDiffuseModel methodsFor: 'control' stamp: 'NicolasBecu 4/29/2018 23:05'!
stepSynchronously: t
	self activeCells
		do: [ :a | 
			a evaporate.
			a diffuse ].
	self updateActiveCells.
	self activeCells do: [ :a | a updateState ].
	self theCMDiffuseAnts do: [ :a | a step ].
	self updateActiveCells! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'NicolasBecu 4/29/2018 23:06'!
theCMDiffuseAnts
	^ theCMDiffuseAnts ifNil: [ theCMDiffuseAnts := OrderedCollection new ]! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'NicolasBecu 4/29/2018 23:06'!
theCMDiffuseAnts: aCollection
	theCMDiffuseAnts := aCollection! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'NicolasBecu 4/29/2018 23:06'!
theCMDiffuseCells
	^ theCMDiffuseCells ifNil: [ theCMDiffuseCells := OrderedCollection new ]! !

!CMDiffuseModel methodsFor: 'accessing' stamp: 'NicolasBecu 4/29/2018 23:06'!
theCMDiffuseCells: aCollection
	theCMDiffuseCells := aCollection! !

!CMDiffuseModel methodsFor: 'optimize' stamp: 'SergeStinckwich 4/3/2016 16:13'!
updateActiveCells
	self activeCells addAll: self newActiveCells.
	self activeCells removeAll: self noMoreActiveCells.
	self newActiveCells: Set new.
	self noMoreActiveCells: Set new! !

CMSpatialEntityElement subclass: #CMDiffuseCell
	instanceVariableNames: 'qty lostOrReceivedQty'
	classVariableNames: 'CurrentId'
	poolDictionaries: ''
	category: 'Cormas-Model-Diffuse'!

CMDiffuseCell class
	instanceVariableNames: 'minimunState diffusionRate evaporationRate scheduler'!

!CMDiffuseCell commentStamp: 'NicolasBecu 4/30/2018 09:38' prior: 0!
I'm a Cell in Diffuse model!

CMDiffuseCell class
	instanceVariableNames: 'minimunState diffusionRate evaporationRate scheduler'!

!CMDiffuseCell class methodsFor: 'id' stamp: 'SergeStinckwich 4/3/2016 16:19'!
CurrentId
	^ CurrentId isNil
		ifTrue: [ 0 ]
		ifFalse: [ CurrentId ]! !

!CMDiffuseCell class methodsFor: 'id' stamp: 'SergeStinckwich 4/3/2016 16:19'!
CurrentId: x
	^ CurrentId := x! !

!CMDiffuseCell class methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:19'!
diffusionRate
	"Getter accessor with default value = 50 % "

	diffusionRate isNil
		ifTrue: [ diffusionRate := 0.5 ].
	^ diffusionRate! !

!CMDiffuseCell class methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:19'!
diffusionRate: anObject
	diffusionRate := anObject! !

!CMDiffuseCell class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:20'!
diffusionRate_default
	"Return the default value of diffusionRate attribute"

	^ 0.5! !

!CMDiffuseCell class methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:20'!
evaporationRate
	"Getter accessor with default value = 0.1 "

	evaporationRate isNil
		ifTrue: [ evaporationRate := 0.1 ].
	^ evaporationRate! !

!CMDiffuseCell class methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:20'!
evaporationRate: anObject
	evaporationRate := anObject! !

!CMDiffuseCell class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:20'!
evaporationRate_default
	"Return the default value of evaporationRate attribute"

	^ 0.1! !

!CMDiffuseCell class methodsFor: 'testing' stamp: 'SergeStinckwich 4/3/2016 16:20'!
isAbstract
	^ false! !

!CMDiffuseCell class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:20'!
lostOrReceivedQty_default
	"Return the default value of lostOrReceivedQty attribute"

	^ 0! !

!CMDiffuseCell class methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:20'!
minimunState
	"Getter accessor with default value = 1 "

	minimunState isNil
		ifTrue: [ minimunState := 1 ].
	^ minimunState! !

!CMDiffuseCell class methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:20'!
minimunState: anObject
	minimunState := anObject! !

!CMDiffuseCell class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:20'!
minimunState_default
	"Return the default value of minimunState attribute"

	^ 1! !

!CMDiffuseCell class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:20'!
qty_default
	"Return the default value of qty attribute"

	^ 0! !

!CMDiffuseCell class methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:20'!
scheduler
	^ scheduler! !

!CMDiffuseCell class methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:20'!
scheduler: anObject
	scheduler := anObject! !

!CMDiffuseCell class methodsFor: '- default value' stamp: 'SergeStinckwich 4/3/2016 16:21'!
scheduler_default
	"Return the default value of scheduler attribute"

	^ nil! !

!CMDiffuseCell methodsFor: 'control' stamp: 'SergeStinckwich 4/3/2016 16:14'!
connexity
	self spaceModel nbNeighbours = #eight
		ifTrue: [ ^ 8 ].
	self spaceModel nbNeighbours = #four
		ifTrue: [ ^ 4 ].
	self spaceModel nbNeighbours = #six
		ifTrue: [ ^ 6 ]! !

!CMDiffuseCell methodsFor: 'control' stamp: 'SergeStinckwich 8/17/2017 15:11'!
diffuse
	"Diffusion of hormons around the cell.
Each neighbours will receive a quantity equals to qty*diffusionRate/connexity.
diffusionRate is the % of hormon I should give to my neigbourhood.
If I am at the edge, I will give less hormons"

	| qtyToGiveToEachCell qtyGiven |
	self qty > 0
		ifTrue: [ qtyToGiveToEachCell := self qty * CMDiffuseCell diffusionRate / self connexity.
			qtyGiven := 0.
			self neighbourhood
				do: [ :c | 
					qtyGiven := qtyGiven + qtyToGiveToEachCell.
					c lostOrReceivedQty: c lostOrReceivedQty + qtyToGiveToEachCell ].
			self lostOrReceivedQty: self lostOrReceivedQty - qtyGiven ]! !

!CMDiffuseCell methodsFor: 'control' stamp: 'SergeStinckwich 8/17/2017 15:11'!
diffuse2
	"Diffusion of hormons around the cell.
Each neighbours will receive a quantity equals to
diffusionRate is the % of hormon I will give to my neigbourhood"

	| qtyToGiveToEachCell |
	self qty > 0
		ifTrue: [ qtyToGiveToEachCell := self qty * CMDiffuseCell diffusionRate / self neighbourhood size.
			self neighbourhood do: [ :c | c lostOrReceivedQty: c lostOrReceivedQty + qtyToGiveToEachCell ].
			self lostOrReceivedQty: self lostOrReceivedQty - (self qty * CMDiffuseCell diffusionRate) ]! !

!CMDiffuseCell methodsFor: 'control' stamp: 'SergeStinckwich 8/17/2017 15:11'!
evaporate
	self qty: (self qty - (self qty * CMDiffuseCell evaporationRate) max: 0)! !

!CMDiffuseCell methodsFor: 'info' stamp: 'SergeStinckwich 4/3/2016 16:15'!
info_Qty
	^ self qty! !

!CMDiffuseCell methodsFor: 'init' stamp: 'SergeStinckwich 4/3/2016 16:15'!
initEmpty
	self qty: 0.
	self lostOrReceivedQty: self qty! !

!CMDiffuseCell methodsFor: 'init' stamp: 'SergeStinckwich 4/3/2016 16:15'!
initId
	self id: (self class CurrentId: self class CurrentId + 1)! !

!CMDiffuseCell methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:17'!
lostOrReceivedQty
	"Getter accessor with default value = 0 "

	lostOrReceivedQty isNil
		ifTrue: [ lostOrReceivedQty := 0 ].
	^ lostOrReceivedQty! !

!CMDiffuseCell methodsFor: 'accessing' stamp: 'SergeStinckwich 8/17/2017 15:11'!
lostOrReceivedQty: anObject
	lostOrReceivedQty := anObject.
	CMDiffuseCell scheduler newActiveCells add: self! !

!CMDiffuseCell methodsFor: 'manipulation' stamp: 'SergeStinckwich 4/3/2016 16:17'!
methodsForManipulation
	^ #('diffuse' 'evaporate' 'initEmpty')! !

!CMDiffuseCell methodsFor: 'pov' stamp: 'NicolasBecu 4/29/2018 22:42'!
pov
	^ self
		povAttribute: #qty
		min: 0
		max: 100
		color: Color green ! !

!CMDiffuseCell methodsFor: 'accessing' stamp: 'SergeStinckwich 4/3/2016 16:17'!
qty
	"Getter accessor with default value = 0 "

	qty isNil
		ifTrue: [ qty := 0 ].
	^ qty! !

!CMDiffuseCell methodsFor: 'accessing' stamp: 'SergeStinckwich 8/17/2017 15:11'!
qty: anObject
	qty := anObject.
	qty > 0
		ifTrue: [ CMDiffuseCell scheduler newActiveCells add: self ]
		ifFalse: [ CMDiffuseCell scheduler noMoreActiveCells add: self ].
	self
		defineVisualState;
		show! !

!CMDiffuseCell methodsFor: 'control' stamp: 'SergeStinckwich 8/17/2017 15:11'!
updateState
	self lostOrReceivedQty ~= 0
		ifTrue: [ self qty: (self qty + self lostOrReceivedQty) asFloat.
			self lostOrReceivedQty: 0.
			self qty < CMDiffuseCell minimunState
				ifTrue: [ self qty: 0 ] ]! !
